## sortmerna 2.0

=== debian/changelog ===
sortmerna (2.0-1) unstable; urgency=medium

  * Initial upload to Debian (Closes: #794607)

 -- Andreas Tille <tille@debian.org>  Tue, 04 Aug 2015 21:27:07 +0200

sortmerna (2.0-0biolinux1) trusty; urgency=medium

  * Initial release.
  * Lose memcheck.h from the build to simplify licensing.

 -- Tim Booth <tbooth@ceh.ac.uk>  Fri, 13 Feb 2015 18:00:35 +0000
