=== debian/control ===
Source: sortmerna
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Tim Booth <tbooth@ceh.ac.uk>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9), dh-autoreconf
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/sortmerna/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/sortmerna/trunk/
Homepage: http://bioinfo.lifl.fr/RNA/sortmerna/

Package: sortmerna
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: python
Description: tool for filtering, mapping and OTU-picking NGS reads
 SortMeRNA is a biological sequence analysis tool for filtering, mapping and
 OTU-picking NGS reads. The core algorithm is based on approximate seeds and
 allows for fast and sensitive analyses of nucleotide sequences. The main
 application of SortMeRNA is filtering rRNA from metatranscriptomic data.
 Additional applications include OTU-picking and taxonomy assignation available
 through QIIME v1.9+ (http://qiime.org - v1.9.0-rc1).
 SortMeRNA takes as input a file of reads (fasta or fastq format) and one or
 multiple rRNA database file(s), and sorts apart rRNA and rejected reads into
 two files specified by the user. Optionally, it can provide high quality local
 alignments of rRNA reads against the rRNA database. SortMeRNA works with
 Illumina, 454, Ion Torrent and PacBio data, and can produce SAM and
 BLAST-like alignments.
