=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --includedir=/usr/include/sortmerna

override_dh_clean:
	dh_clean
	rm -f index/.tobuild
	rm -f include/memcheck.h
	rm -rf tmp

override_dh_auto_build:
	touch index/.tobuild
	dh_auto_build
	mkdir -p tmp
	cat debian/README_scripts.txt rRNA_databases/README.txt > tmp/README.txt

override_dh_auto_install:
	#Skip this - do it manually
	true

override_dh_fixperms:
	dh_fixperms
	find debian/sortmerna -name '*.sh' -exec chmod +x '{}' ';'
	find debian/sortmerna -name '*.py' -exec chmod -x '{}' ';'

override_dh_compress:
	dh_compress --exclude=.pdf
