## sortmerna 2.1

=== debian/changelog ===
sortmerna (2.1-5) unstable; urgency=medium

  * Team upload.

  [ Pranav Ballaney ]
  * Add autopkgtest template and README.test
  * Install examples
  * Add autopkgtests

  [ Andreas Tille ]
  * Standards-Version: 4.5.0 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Pranav Ballaney <ballaneypranav@gmail.com>  Sat, 21 Mar 2020 00:57:31 +0530

sortmerna (2.1-4) unstable; urgency=medium

  * Use 2to3 to port from Python2 to Python3
    Closes: #945707
  * debhelper-compat 12
  * Standards-Version: 4.4.1
  * Secure URI in copyright format
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit (from
    ./configure), Repository, Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Wed, 25 Dec 2019 21:25:41 +0100

sortmerna (2.1-3) unstable; urgency=medium

  [ Steffen Moeller ]
  * debian/upstream/metadata
    - added references to registries
    - yamllint cleanliness

  [ Andreas Tille ]
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1

 -- Andreas Tille <tille@debian.org>  Tue, 09 Oct 2018 17:26:27 +0200

sortmerna (2.1-2) unstable; urgency=medium

  * Moved packaging from SVN to Git
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)
  * Restrict set of architectures, Depends: sse2-support on i386
    Closes: #818505
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Mon, 25 Sep 2017 13:32:01 +0200

sortmerna (2.1-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Thu, 10 Mar 2016 23:39:18 +0100
