=== debian/control ===
--- 
+++ 
@@ -4,17 +4,22 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9), dh-autoreconf
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/sortmerna/trunk/
-Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/sortmerna/trunk/
-Homepage: http://bioinfo.lifl.fr/RNA/sortmerna/
+Build-Depends: debhelper-compat (= 12),
+#               python3 <!nocheck>,
+#               python3-skbio <!nocheck>,
+Standards-Version: 4.5.0
+Vcs-Browser: https://salsa.debian.org/med-team/sortmerna
+Vcs-Git: https://salsa.debian.org/med-team/sortmerna.git
+Homepage: https://bioinfo.lifl.fr/RNA/sortmerna/
+Rules-Requires-Root: no
 
 Package: sortmerna
-Architecture: any
+Architecture: any-amd64 any-i386 x32
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
-Recommends: python
+         ${misc:Depends},
+         sse2-support [any-i386]
+Recommends: python3,
+#            python3-skbio
 Description: tool for filtering, mapping and OTU-picking NGS reads
  SortMeRNA is a biological sequence analysis tool for filtering, mapping and
  OTU-picking NGS reads. The core algorithm is based on approximate seeds and
@@ -28,4 +33,3 @@
  alignments of rRNA reads against the rRNA database. SortMeRNA works with
  Illumina, 454, Ion Torrent and PacBio data, and can produce SAM and
  BLAST-like alignments.
-
