=== debian/watch ===
version=3
# The file naming is inconsistent, so you'll need to look here manually:
# http://bioinfo.lifl.fr/RNA/sortmerna/
https://github.com/biocore/sortmerna/releases .*/archive/(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
