## sortmerna 4.3.6

=== debian/changelog ===
sortmerna (4.3.6-2) unstable; urgency=medium

  * d/rules: remove dh_clean override; not needed anymore.
  * d/rules: move to execute_after_ statements.
  * d/rules: verbose remove of cmake/ directories.
  * d/rules: verbose permissions changes.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.6.2.
  * d/rules: build for i386 with -msse2.
    The package depends on sse2-support for that architecture, so this is
    not a baseline violation in this particular case. (Closes: #1028122)

 -- Étienne Mollier <emollier@debian.org>  Sat, 07 Jan 2023 16:52:43 +0100

sortmerna (4.3.6-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 29 Nov 2022 18:06:13 +0100

sortmerna (4.3.4-1) experimental; urgency=medium

  [ Steffen Möller ]
  * Update watch - we missed a couple of versions

  [ Andreas Tille ]
  * New upstream version
  * debhelper-compat 13 (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Build-Depends: cmake
  * Remove Tim Booth from Uploaders (thanks for all your work Tim)
  * Versioned Build-Depends: librocksdb-dev (>= 6.25.3)
  * Build-Depends: libgflags-dev, libsnappy-dev, libzstd-dev
    (needed by librocksdb-dev (>= 6.25.3) - see #1004665)
  * Build-Depends: rapidjson-dev, libconcurrentqueue-dev
  * Review copyright
  * Deactivate autopkgtest which is based on binary indexdb_rna
    which is not available any more
  * Use tags in watch file
  * Warn users about missing binary indexdb_rna in NEWS.Debian

 -- Andreas Tille <tille@debian.org>  Tue, 15 Feb 2022 19:51:10 +0100
