=== debian/control ===
--- 
+++ 
@@ -1,13 +1,20 @@
 Source: sortmerna
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Tim Booth <tbooth@ceh.ac.uk>,
-           Andreas Tille <tille@debian.org>
+Uploaders: Andreas Tille <tille@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
+               cmake,
+               librocksdb-dev (>= 6.25.3),
+               libgflags-dev,
+               libsnappy-dev,
+               libzstd-dev,
+               rapidjson-dev,
+               libconcurrentqueue-dev
 #               python3 <!nocheck>,
 #               python3-skbio <!nocheck>,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/sortmerna
 Vcs-Git: https://salsa.debian.org/med-team/sortmerna.git
 Homepage: https://bioinfo.lifl.fr/RNA/sortmerna/
