=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%sortmerna-$1.tar.gz%" \
   https://github.com/biocore/sortmerna/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
